import { useState, useMemo } from 'react';
import './App.css';

function App() {
    const [apiResult, setApiResult] = useState();

    const contents = useMemo(() => {
        return <label>
                 Response:
                 <textarea name="responseContent" rows={25} cols={150} value={apiResult} readOnly={true}></textarea>
               </label>;
    }, [apiResult])
    
    return (
        <div>
            <h1 id="tabelLabel">Tridion Docs Demo Application</h1>
            <button onClick={login}>
                Login
            </button>
            <button onClick={logout}>
                Logout
            </button>
            <button onClick={user}>
                User
            </button>
            <button onClick={version}>
                Version
            </button>
            <button onClick={whoAmI}>
                Who Am I
            </button>
            <p>Demonstrating API call response.</p>
            {contents}
        </div>
    );

    async function login() {
        window.location.href = '/bff/login?returnUrl=/';
    }
    
    async function user() {
        const response = await fetch('/bff/user');
        if (!response.ok)
        {
            const data = response.status + ' ' + response.statusText;
            setApiResult(data);
        }
        else
        {
            const data = await response.json();
            setApiResult(JSON.stringify(data, null, 2));
        }
    }

    async function logout() {
        const response = await fetch('/bff/logout');
        if (response.redirected) {
            window.location.href = response.url;
        }
        const data = 'logout' + await response.text();
        setApiResult(data);
    }
    
    async function version() {
        const response = await fetch('/tridion/version');
        if (!response.ok)
        {
            const data = response.status + ' ' + response.statusText;
            setApiResult(data);
        }
        else {
            const data = await response.text();
            setApiResult(data);
        }
    }

    async function whoAmI() {
        const response = await fetch('/tridion/whoami');
        if (!response.ok)
        {
            const data = response.status + ' ' + response.statusText;
            setApiResult(data);
        }
        else {
            const data = await response.text();
            setApiResult(data);
        }
    }
}

export default App;