using System.IdentityModel.Selectors;
using System.ServiceModel.Description;

namespace ReactApp.Server.Security;

internal sealed class BearerCredentials : ClientCredentials
{
    internal readonly string AccessToken;

    internal BearerCredentials(string accessToken)
        => AccessToken = accessToken;

    private BearerCredentials(BearerCredentials cred) : base(cred)
        => AccessToken = cred.AccessToken;

    public override SecurityTokenManager CreateSecurityTokenManager()
        => new BearerCredentialsSecurityTokenManager(this);

    protected override ClientCredentials CloneCore()
        => new BearerCredentials(this);    
}