using System.IdentityModel.Selectors;
using System.ServiceModel;

namespace ReactApp.Server.Security;

internal sealed class BearerCredentialsSecurityTokenManager : ClientCredentialsSecurityTokenManager
{
    internal BearerCredentialsSecurityTokenManager(BearerCredentials clientCredentials) : base(clientCredentials)
    {
    }

    public override SecurityTokenProvider CreateSecurityTokenProvider(SecurityTokenRequirement tokenRequirement)
        => new BearerCredentialsSecurityTokenProvider((BearerCredentials) ClientCredentials);

    public override SecurityTokenSerializer CreateSecurityTokenSerializer(SecurityTokenVersion version)
        => new BearerCredentialsTokenSerializer();    
}